#define ALPHABET_SIZE 256
#define DELIMITER '\0'
#define MAX(x, y) (((x) > (y)) ? (x) : (y))

#include <stdlib.h>
#include <string.h>

/**
 * Own implementation of strdup, heavily inspired by the glibc source code.
 *
 * This is neccessary because subGIT does not seem to have a strdup
 * implementation available for use.
 *
 * @param s string to duplicate
 * @return pointer to the newly allocated string
 */
char *my_strdup(const char *s) {
  size_t len = strlen(s);
  char *new = malloc(len + 1);
  new[len] = DELIMITER;

  return (char *)memcpy(new, s, len);
}

/**
 * Own implementation of strndup, heavily inspired by the glibc source code.
 *
 * This is neccessary because subGIT does not seem to have a strndup
 * implementation available for use.
 *
 * @param s string to duplicate
 * @return pointer to the newly allocated string
 */
char *my_strndup(const char *s, size_t n) {
  size_t string_len = strlen(s);
  size_t len = MAX(string_len, n);
  char *new = (char *)malloc(len + 1);

  new[len] = DELIMITER;

  return (char *)memcpy(new, s, len);
}
